This object is created internally and returned from {@link request}. It represents an in-progress request whose header has already been queued. The header is still mutable using the `setHeader(name, value)`,`getHeader(name)`, `removeHeader(name)` API. The actual header will be sent along with the first data chunk or when calling `request.end()`.

To get the response, add a listener for `'response'` to the request object.`'response'` will be emitted from the request object when the response headers have been received. The `'response'` event is executed with one argument which is an instance of IncomingMessage.

During the `'response'` event, one can add listeners to the response object; particularly to listen for the `'data'` event.

If no `'response'` handler is added, then the response will be entirely discarded. However, if a `'response'` event handler is added, then the data from the response object must be consumed, either by calling `response.read()` whenever there is a `'readable'` event, or by adding a `'data'` handler, or by calling the `.resume()` method. Until the data is consumed, the `'end'` event will not fire. Also, until the data is read it will consume memory that can eventually lead to a 'process out of memory' error.

For backward compatibility, `res` will only emit `'error'` if there is an`'error'` listener registered.

Node.js does not check whether Content-Length and the length of the body which has been transmitted are equal or not.

since

  v0.1.17

### Hierarchy

- OutgoingMessage
  - ClientRequest

## Index

### Constructors

- constructor

### Properties

- aborted
- chunkedEncoding
- connection
- destroyed
- finished
- headersSent
- host
- maxHeadersCount
- method
- path
- protocol
- req
- reusedSocket
- sendDate
- shouldKeepAlive
- socket
- useChunkedEncodingByDefault
- writable
- writableCorked
- writableEnded
- writableFinished
- writableHighWaterMark
- writableLength
- writableObjectMode
- captureRejectionSymbol
- captureRejections
- defaultMaxListeners
- errorMonitor

### Methods

- _construct
- _destroy
- _final
- _write
- _writev
- abort
- addListener
- addTrailers
- cork
- destroy
- emit
- end
- eventNames
- flushHeaders
- getHeader
- getHeaderNames
- getHeaders
- getMaxListeners
- getRawHeaderNames
- hasHeader
- listenerCount
- listeners
- off
- on
- onSocket
- once
- pipe
- prependListener
- prependOnceListener
- rawListeners
- removeAllListeners
- removeHeader
- removeListener
- setDefaultEncoding
- setHeader
- setMaxListeners
- setNoDelay
- setSocketKeepAlive
- setTimeout
- uncork
- write
- getEventListeners
- listenerCount
- on
- once

## Constructors

### constructor

- new ClientRequest(url: string | URL | ClientRequestArgs, cb?: (res: IncomingMessage) => void): ClientRequest

- Overrides OutgoingMessage.constructor

  #### Parameters

  - ##### url: string | URL | ClientRequestArgs

  - ##### Optional cb: (res: IncomingMessage) => void

    - - (res: IncomingMessage): void

      - #### Parameters

        - ##### res: IncomingMessage

        #### Returns void

  #### Returns ClientRequest

## Properties

### aborted

aborted: boolean

The `request.aborted` property will be `true` if the request has been aborted.

since

  v0.11.14

### chunkedEncoding

chunkedEncoding: boolean

Inherited from OutgoingMessage.chunkedEncoding

### Readonly connection

connection: Socket

Inherited from OutgoingMessage.connection

Aliases of `outgoingMessage.socket`

since

  v0.3.0

deprecated

  Since v15.12.0 - Use `socket` instead.

### destroyed

destroyed: boolean

Inherited from OutgoingMessage.destroyed

Is `true` after `writable.destroy()` has been called.

since

  v8.0.0

### finished

finished: boolean

Inherited from OutgoingMessage.finished

deprecated

  Use `writableEnded` instead.

### Readonly headersSent

headersSent: boolean

Inherited from OutgoingMessage.headersSent

Read-only. `true` if the headers were sent, otherwise `false`.

since

  v0.9.3

### host

host: string

The request host.

since

  v14.5.0, v12.19.0

### maxHeadersCount

maxHeadersCount: number

Limits maximum response headers count. If set to 0, no limit will be applied.

default

  2000

### method

method: string

The request method.

since

  v0.1.97

### path

path: string

The request path.

since

  v0.4.0

### protocol

protocol: string

The request protocol.

since

  v14.5.0, v12.19.0

### Readonly req

req: IncomingMessage

Inherited from OutgoingMessage.req

### reusedSocket

reusedSocket: boolean

Whether the request is send through a reused socket.

since

  v13.0.0, v12.16.0

### sendDate

sendDate: boolean

Inherited from OutgoingMessage.sendDate

### shouldKeepAlive

shouldKeepAlive: boolean

Inherited from OutgoingMessage.shouldKeepAlive

### Readonly socket

socket: Socket

Inherited from OutgoingMessage.socket

Reference to the underlying socket. Usually, users will not want to access this property.

After calling `outgoingMessage.end()`, this property will be nulled.

since

  v0.3.0

### useChunkedEncodingByDefault

useChunkedEncodingByDefault: boolean

Inherited from OutgoingMessage.useChunkedEncodingByDefault

### Readonly writable

writable: boolean

Inherited from OutgoingMessage.writable

Is `true` if it is safe to call `writable.write()`, which means the stream has not been destroyed, errored or ended.

since

  v11.4.0

### Readonly writableCorked

writableCorked: number

Inherited from OutgoingMessage.writableCorked

Number of times `writable.uncork()` needs to be called in order to fully uncork the stream.

since

  v13.2.0, v12.16.0

### Readonly writableEnded

writableEnded: boolean

Inherited from OutgoingMessage.writableEnded

Is `true` after `writable.end()` has been called. This property does not indicate whether the data has been flushed, for this use `writable.writableFinished` instead.

since

  v12.9.0

### Readonly writableFinished

writableFinished: boolean

Inherited from OutgoingMessage.writableFinished

Is set to `true` immediately before the `'finish'` event is emitted.

since

  v12.6.0

### Readonly writableHighWaterMark

writableHighWaterMark: number

Inherited from OutgoingMessage.writableHighWaterMark

Return the value of `highWaterMark` passed when creating this `Writable`.

since

  v9.3.0

### Readonly writableLength

writableLength: number

Inherited from OutgoingMessage.writableLength

This property contains the number of bytes (or objects) in the queue ready to be written. The value provides introspection data regarding the status of the `highWaterMark`.

since

  v9.4.0

### Readonly writableObjectMode

writableObjectMode: boolean

Inherited from OutgoingMessage.writableObjectMode

Getter for the property `objectMode` of a given `Writable` stream.

since

  v12.3.0

### Static Readonly captureRejectionSymbol

captureRejectionSymbol: typeof captureRejectionSymbol

Inherited from OutgoingMessage.captureRejectionSymbol

### Static captureRejections

captureRejections: boolean

Inherited from OutgoingMessage.captureRejections

Sets or gets the default captureRejection value for all emitters.

### Static defaultMaxListeners

defaultMaxListeners: number

Inherited from OutgoingMessage.defaultMaxListeners

### Static Readonly errorMonitor

errorMonitor: typeof errorMonitor

Inherited from OutgoingMessage.errorMonitor

This symbol shall be used to install a listener for only monitoring `'error'` events. Listeners installed using this symbol are called before the regular `'error'` listeners are called.

Installing a listener using this symbol does not change the behavior once an `'error'` event is emitted, therefore the process will still crash if no regular `'error'` listener is installed.

## Methods

### Optional _construct

- _construct(callback: (error?: <internal>.Error) => void): void

- Inherited from OutgoingMessage._construct

  #### Parameters

  - ##### callback: (error?: <internal>.Error) => void

    - - (error?: <internal>.Error): void

      - #### Parameters

        - ##### Optional error: <internal>.Error

        #### Returns void

### _destroy

- _destroy(error: <internal>.Error, callback: (error?: <internal>.Error) => void): void

- Inherited from OutgoingMessage._destroy

  #### Parameters

  - ##### error: <internal>.Error

  - ##### callback: (error?: <internal>.Error) => void

    - - (error?: <internal>.Error): void

      - #### Parameters

        - ##### Optional error: <internal>.Error

        #### Returns void

### _final

- _final(callback: (error?: <internal>.Error) => void): void

- Inherited from OutgoingMessage._final

  #### Parameters

  - ##### callback: (error?: <internal>.Error) => void

    - - (error?: <internal>.Error): void

      - #### Parameters

        - ##### Optional error: <internal>.Error

        #### Returns void

### _write

- _write(chunk: any, encoding: BufferEncoding, callback: (error?: <internal>.Error) => void): void

- Inherited from OutgoingMessage._write

  #### Parameters

  - ##### chunk: any

  - ##### encoding: BufferEncoding

  - ##### callback: (error?: <internal>.Error) => void

    - - (error?: <internal>.Error): void

      - #### Parameters

        - ##### Optional error: <internal>.Error

        #### Returns void

### Optional _writev

- _writev(chunks: { chunk: any; encoding: BufferEncoding }[], callback: (error?: <internal>.Error) => void): void

- Inherited from OutgoingMessage._writev

  #### Parameters

  - ##### chunks: { chunk: any; encoding: BufferEncoding }[]

  - ##### callback: (error?: <internal>.Error) => void

    - - (error?: <internal>.Error): void

      - #### Parameters

        - ##### Optional error: <internal>.Error

        #### Returns void

### abort

- abort(): void

- Marks the request as aborting. Calling this will cause remaining data in the response to be dropped and the socket to be destroyed.

  since

    v0.3.8

  deprecated

    Since v14.1.0,v13.14.0 - Use `destroy` instead.

  #### Returns void

### addListener

- addListener(event: "abort", listener: () => void): ClientRequest
- addListener(event: "connect", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- addListener(event: "continue", listener: () => void): ClientRequest
- addListener(event: "information", listener: (info: InformationEvent) => void): ClientRequest
- addListener(event: "response", listener: (response: IncomingMessage) => void): ClientRequest
- addListener(event: "socket", listener: (socket: Socket) => void): ClientRequest
- addListener(event: "timeout", listener: () => void): ClientRequest
- addListener(event: "upgrade", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- addListener(event: "close", listener: () => void): ClientRequest
- addListener(event: "drain", listener: () => void): ClientRequest
- addListener(event: "error", listener: (err: <internal>.Error) => void): ClientRequest
- addListener(event: "finish", listener: () => void): ClientRequest
- addListener(event: "pipe", listener: (src: <internal>.Readable) => void): ClientRequest
- addListener(event: "unpipe", listener: (src: <internal>.Readable) => void): ClientRequest
- addListener(event: string | symbol, listener: (...args: any[]) => void): ClientRequest

- Overrides OutgoingMessage.addListener

  Event emitter The defined events on documents including:

  1. close
  2. drain
  3. error
  4. finish
  5. pipe
  6. unpipe

  #### Parameters

  - ##### event: "abort"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "connect"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "continue"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "information"

  - ##### listener: (info: InformationEvent) => void

    - - (info: InformationEvent): void

      - #### Parameters

        - ##### info: InformationEvent

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "response"

  - ##### listener: (response: IncomingMessage) => void

    - - (response: IncomingMessage): void

      - #### Parameters

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "socket"

  - ##### listener: (socket: Socket) => void

    - - (socket: Socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "timeout"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "close"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "drain"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "finish"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "pipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: "unpipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.addListener

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns ClientRequest

### addTrailers

- addTrailers(headers: OutgoingHttpHeaders | readonly [string, string][]): void

- Inherited from OutgoingMessage.addTrailers

  Adds HTTP trailers (headers but at the end of the message) to the message.

  Trailers are only be emitted if the message is chunked encoded. If not, the trailer will be silently discarded.

  HTTP requires the `Trailer` header to be sent to emit trailers, with a list of header fields in its value, e.g.

      message.writeHead(200, { 'Content-Type': 'text/plain',
                               'Trailer': 'Content-MD5' });
      message.write(fileData);
      message.addTrailers({ 'Content-MD5': '7895bf4b8828b55ceaf47747b4bca667' });
      message.end();

  Attempting to set a header field name or value that contains invalid characters will result in a `TypeError` being thrown.

  since

    v0.3.0

  #### Parameters

  - ##### headers: OutgoingHttpHeaders | readonly [string, string][]

  #### Returns void

### cork

- cork(): void

- Inherited from OutgoingMessage.cork

  The `writable.cork()` method forces all written data to be buffered in memory. The buffered data will be flushed when either the uncork or end methods are called.

  The primary intent of `writable.cork()` is to accommodate a situation in which several small chunks are written to the stream in rapid succession. Instead of immediately forwarding them to the underlying destination, `writable.cork()`buffers all the chunks until `writable.uncork()` is called, which will pass them all to `writable._writev()`, if present. This prevents a head-of-line blocking situation where data is being buffered while waiting for the first small chunk to be processed. However, use of `writable.cork()` without implementing`writable._writev()` may have an adverse effect on throughput.

  See also: `writable.uncork()`, `writable._writev()`.

  since

    v0.11.2

  #### Returns void

### destroy

- destroy(error?: <internal>.Error): ClientRequest

- Inherited from OutgoingMessage.destroy

  Destroy the stream. Optionally emit an `'error'` event, and emit a `'close'`event (unless `emitClose` is set to `false`). After this call, the writable stream has ended and subsequent calls to `write()` or `end()` will result in an `ERR_STREAM_DESTROYED` error. This is a destructive and immediate way to destroy a stream. Previous calls to`write()` may not have drained, and may trigger an `ERR_STREAM_DESTROYED` error. Use `end()` instead of destroy if data should flush before close, or wait for the `'drain'` event before destroying the stream.

  Once `destroy()` has been called any further calls will be a no-op and no further errors except from `_destroy()` may be emitted as `'error'`.

  Implementors should not override this method, but instead implement `writable._destroy()`.

  since

    v8.0.0

  #### Parameters

  - ##### Optional error: <internal>.Error

    Optional, an error to emit with `'error'` event.

  #### Returns ClientRequest

### emit

- emit(event: "close"): boolean
- emit(event: "drain"): boolean
- emit(event: "error", err: <internal>.Error): boolean
- emit(event: "finish"): boolean
- emit(event: "pipe", src: <internal>.Readable): boolean
- emit(event: "unpipe", src: <internal>.Readable): boolean
- emit(event: string | symbol, ...args: any[]): boolean

- Inherited from OutgoingMessage.emit

  Synchronously calls each of the listeners registered for the event named`eventName`, in the order they were registered, passing the supplied arguments to each.

  Returns `true` if the event had listeners, `false` otherwise.

      const EventEmitter = require('events');
      const myEmitter = new EventEmitter();

      // First listener
      myEmitter.on('event', function firstListener() {
        console.log('Helloooo! first listener');
      });
      // Second listener
      myEmitter.on('event', function secondListener(arg1, arg2) {
        console.log(`event with parameters ${arg1}, ${arg2} in second listener`);
      });
      // Third listener
      myEmitter.on('event', function thirdListener(...args) {
        const parameters = args.join(', ');
        console.log(`event with parameters ${parameters} in third listener`);
      });

      console.log(myEmitter.listeners('event'));

      myEmitter.emit('event', 1, 2, 3, 4, 5);

      // Prints:
      // [
      //   [Function: firstListener],
      //   [Function: secondListener],
      //   [Function: thirdListener]
      // ]
      // Helloooo! first listener
      // event with parameters 1, 2 in second listener
      // event with parameters 1, 2, 3, 4, 5 in third listener

  #### Parameters

  - ##### event: "close"

  #### Returns boolean

- Inherited from OutgoingMessage.emit

  #### Parameters

  - ##### event: "drain"

  #### Returns boolean

- Inherited from OutgoingMessage.emit

  #### Parameters

  - ##### event: "error"

  - ##### err: <internal>.Error

  #### Returns boolean

- Inherited from OutgoingMessage.emit

  #### Parameters

  - ##### event: "finish"

  #### Returns boolean

- Inherited from OutgoingMessage.emit

  #### Parameters

  - ##### event: "pipe"

  - ##### src: <internal>.Readable

  #### Returns boolean

- Inherited from OutgoingMessage.emit

  #### Parameters

  - ##### event: "unpipe"

  - ##### src: <internal>.Readable

  #### Returns boolean

- Inherited from OutgoingMessage.emit

  #### Parameters

  - ##### event: string | symbol

  - ##### Rest ...args: any[]

  #### Returns boolean

### end

- end(cb?: () => void): ClientRequest
- end(chunk: any, cb?: () => void): ClientRequest
- end(chunk: any, encoding: BufferEncoding, cb?: () => void): ClientRequest

- Inherited from OutgoingMessage.end

  Calling the `writable.end()` method signals that no more data will be written to the `Writable`. The optional `chunk` and `encoding` arguments allow one final additional chunk of data to be written immediately before closing the stream.

  Calling the write method after calling end will raise an error.

      // Write 'hello, ' and then end with 'world!'.
      const fs = require('fs');
      const file = fs.createWriteStream('example.txt');
      file.write('hello, ');
      file.end('world!');
      // Writing more now is not allowed!

  since

    v0.9.4

  #### Parameters

  - ##### Optional cb: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Inherited from OutgoingMessage.end

  #### Parameters

  - ##### chunk: any

  - ##### Optional cb: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Inherited from OutgoingMessage.end

  #### Parameters

  - ##### chunk: any

  - ##### encoding: BufferEncoding

  - ##### Optional cb: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

### eventNames

- eventNames(): (string | symbol)[]

- Inherited from OutgoingMessage.eventNames

  Returns an array listing the events for which the emitter has registered listeners. The values in the array are strings or `Symbol`s.

      const EventEmitter = require('events');
      const myEE = new EventEmitter();
      myEE.on('foo', () => {});
      myEE.on('bar', () => {});

      const sym = Symbol('symbol');
      myEE.on(sym, () => {});

      console.log(myEE.eventNames());
      // Prints: [ 'foo', 'bar', Symbol(symbol) ]

  since

    v6.0.0

  #### Returns (string | symbol)[]

### flushHeaders

- flushHeaders(): void

- Inherited from OutgoingMessage.flushHeaders

  Compulsorily flushes the message headers

  For efficiency reason, Node.js normally buffers the message headers until `outgoingMessage.end()` is called or the first chunk of message data is written. It then tries to pack the headers and data into a single TCP packet.

  It is usually desired (it saves a TCP round-trip), but not when the first data is not sent until possibly much later. `outgoingMessage.flushHeaders()`bypasses the optimization and kickstarts the request.

  since

    v1.6.0

  #### Returns void

### getHeader

- getHeader(name: string): string | number | string[]

- Inherited from OutgoingMessage.getHeader

  Gets the value of HTTP header with the given name. If such a name doesn't exist in message, it will be `undefined`.

  since

    v0.4.0

  #### Parameters

  - ##### name: string

    Name of header

  #### Returns string | number | string[]

### getHeaderNames

- getHeaderNames(): string[]

- Inherited from OutgoingMessage.getHeaderNames

  Returns an array of names of headers of the outgoing outgoingMessage. All names are lowercase.

  since

    v8.0.0

  #### Returns string[]

### getHeaders

- getHeaders(): OutgoingHttpHeaders

- Inherited from OutgoingMessage.getHeaders

  Returns a shallow copy of the current outgoing headers. Since a shallow copy is used, array values may be mutated without additional calls to various header-related HTTP module methods. The keys of the returned object are the header names and the values are the respective header values. All header names are lowercase.

  The object returned by the `outgoingMessage.getHeaders()` method does not prototypically inherit from the JavaScript Object. This means that typical Object methods such as `obj.toString()`, `obj.hasOwnProperty()`, and others are not defined and will not work.

      outgoingMessage.setHeader('Foo', 'bar');
      outgoingMessage.setHeader('Set-Cookie', ['foo=bar', 'bar=baz']);

      const headers = outgoingMessage.getHeaders();
      // headers === { foo: 'bar', 'set-cookie': ['foo=bar', 'bar=baz'] }

  since

    v8.0.0

  #### Returns OutgoingHttpHeaders

### getMaxListeners

- getMaxListeners(): number

- Inherited from OutgoingMessage.getMaxListeners

  Returns the current max listener value for the `EventEmitter` which is either set by `emitter.setMaxListeners(n)` or defaults to defaultMaxListeners.

  since

    v1.0.0

  #### Returns number

### getRawHeaderNames

- getRawHeaderNames(): string[]

- Returns an array containing the unique names of the current outgoing raw headers. Header names are returned with their exact casing being set.

      request.setHeader('Foo', 'bar');
      request.setHeader('Set-Cookie', ['foo=bar', 'bar=baz']);

      const headerNames = request.getRawHeaderNames();
      // headerNames === ['Foo', 'Set-Cookie']

  since

    v15.13.0

  #### Returns string[]

### hasHeader

- hasHeader(name: string): boolean

- Inherited from OutgoingMessage.hasHeader

  Returns `true` if the header identified by `name` is currently set in the outgoing headers. The header name is case-insensitive.

      const hasContentType = outgoingMessage.hasHeader('content-type');

  since

    v8.0.0

  #### Parameters

  - ##### name: string

  #### Returns boolean

### listenerCount

- listenerCount(eventName: string | symbol): number

- Inherited from OutgoingMessage.listenerCount

  Returns the number of listeners listening to the event named `eventName`.

  since

    v3.2.0

  #### Parameters

  - ##### eventName: string | symbol

    The name of the event being listened for

  #### Returns number

### listeners

- listeners(eventName: string | symbol): Function[]

- Inherited from OutgoingMessage.listeners

  Returns a copy of the array of listeners for the event named `eventName`.

      server.on('connection', (stream) => {
        console.log('someone connected!');
      });
      console.log(util.inspect(server.listeners('connection')));
      // Prints: [ [Function] ]

  since

    v0.1.26

  #### Parameters

  - ##### eventName: string | symbol

  #### Returns Function[]

### off

- off(eventName: string | symbol, listener: (...args: any[]) => void): ClientRequest

- Inherited from OutgoingMessage.off

  Alias for `emitter.removeListener()`.

  since

    v10.0.0

  #### Parameters

  - ##### eventName: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns ClientRequest

### on

- on(event: "abort", listener: () => void): ClientRequest
- on(event: "connect", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- on(event: "continue", listener: () => void): ClientRequest
- on(event: "information", listener: (info: InformationEvent) => void): ClientRequest
- on(event: "response", listener: (response: IncomingMessage) => void): ClientRequest
- on(event: "socket", listener: (socket: Socket) => void): ClientRequest
- on(event: "timeout", listener: () => void): ClientRequest
- on(event: "upgrade", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- on(event: "close", listener: () => void): ClientRequest
- on(event: "drain", listener: () => void): ClientRequest
- on(event: "error", listener: (err: <internal>.Error) => void): ClientRequest
- on(event: "finish", listener: () => void): ClientRequest
- on(event: "pipe", listener: (src: <internal>.Readable) => void): ClientRequest
- on(event: "unpipe", listener: (src: <internal>.Readable) => void): ClientRequest
- on(event: string | symbol, listener: (...args: any[]) => void): ClientRequest

- Overrides OutgoingMessage.on

  Adds the `listener` function to the end of the listeners array for the event named `eventName`. No checks are made to see if the `listener` has already been added. Multiple calls passing the same combination of `eventName`and `listener` will result in the `listener` being added, and called, multiple times.

      server.on('connection', (stream) => {
        console.log('someone connected!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  By default, event listeners are invoked in the order they are added. The`emitter.prependListener()` method can be used as an alternative to add the event listener to the beginning of the listeners array.

      const myEE = new EventEmitter();
      myEE.on('foo', () => console.log('a'));
      myEE.prependListener('foo', () => console.log('b'));
      myEE.emit('foo');
      // Prints:
      //   b
      //   a

  #### Parameters

  - ##### event: "abort"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "connect"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "continue"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "information"

  - ##### listener: (info: InformationEvent) => void

    - - (info: InformationEvent): void

      - #### Parameters

        - ##### info: InformationEvent

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "response"

  - ##### listener: (response: IncomingMessage) => void

    - - (response: IncomingMessage): void

      - #### Parameters

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "socket"

  - ##### listener: (socket: Socket) => void

    - - (socket: Socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "timeout"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "close"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "drain"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "finish"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "pipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: "unpipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.on

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns ClientRequest

### onSocket

- onSocket(socket: Socket): void

- #### Parameters

  - ##### socket: Socket

  #### Returns void

### once

- once(event: "abort", listener: () => void): ClientRequest
- once(event: "connect", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- once(event: "continue", listener: () => void): ClientRequest
- once(event: "information", listener: (info: InformationEvent) => void): ClientRequest
- once(event: "response", listener: (response: IncomingMessage) => void): ClientRequest
- once(event: "socket", listener: (socket: Socket) => void): ClientRequest
- once(event: "timeout", listener: () => void): ClientRequest
- once(event: "upgrade", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- once(event: "close", listener: () => void): ClientRequest
- once(event: "drain", listener: () => void): ClientRequest
- once(event: "error", listener: (err: <internal>.Error) => void): ClientRequest
- once(event: "finish", listener: () => void): ClientRequest
- once(event: "pipe", listener: (src: <internal>.Readable) => void): ClientRequest
- once(event: "unpipe", listener: (src: <internal>.Readable) => void): ClientRequest
- once(event: string | symbol, listener: (...args: any[]) => void): ClientRequest

- Overrides OutgoingMessage.once

  Adds a one-time `listener` function for the event named `eventName`. The next time `eventName` is triggered, this listener is removed and then invoked.

      server.once('connection', (stream) => {
        console.log('Ah, we have our first user!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  By default, event listeners are invoked in the order they are added. The`emitter.prependOnceListener()` method can be used as an alternative to add the event listener to the beginning of the listeners array.

      const myEE = new EventEmitter();
      myEE.once('foo', () => console.log('a'));
      myEE.prependOnceListener('foo', () => console.log('b'));
      myEE.emit('foo');
      // Prints:
      //   b
      //   a

  #### Parameters

  - ##### event: "abort"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "connect"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "continue"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "information"

  - ##### listener: (info: InformationEvent) => void

    - - (info: InformationEvent): void

      - #### Parameters

        - ##### info: InformationEvent

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "response"

  - ##### listener: (response: IncomingMessage) => void

    - - (response: IncomingMessage): void

      - #### Parameters

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "socket"

  - ##### listener: (socket: Socket) => void

    - - (socket: Socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "timeout"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "close"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "drain"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "finish"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "pipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: "unpipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.once

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns ClientRequest

### pipe

- pipe<T>(destination: T, options?: { end?: boolean }): T

- Inherited from OutgoingMessage.pipe

  #### Type parameters

  - #### T: WritableStream<T>

  #### Parameters

  - ##### destination: T

  - ##### Optional options: { end?: boolean }

    - ##### Optional end?: boolean

  #### Returns T

### prependListener

- prependListener(event: "abort", listener: () => void): ClientRequest
- prependListener(event: "connect", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- prependListener(event: "continue", listener: () => void): ClientRequest
- prependListener(event: "information", listener: (info: InformationEvent) => void): ClientRequest
- prependListener(event: "response", listener: (response: IncomingMessage) => void): ClientRequest
- prependListener(event: "socket", listener: (socket: Socket) => void): ClientRequest
- prependListener(event: "timeout", listener: () => void): ClientRequest
- prependListener(event: "upgrade", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- prependListener(event: "close", listener: () => void): ClientRequest
- prependListener(event: "drain", listener: () => void): ClientRequest
- prependListener(event: "error", listener: (err: <internal>.Error) => void): ClientRequest
- prependListener(event: "finish", listener: () => void): ClientRequest
- prependListener(event: "pipe", listener: (src: <internal>.Readable) => void): ClientRequest
- prependListener(event: "unpipe", listener: (src: <internal>.Readable) => void): ClientRequest
- prependListener(event: string | symbol, listener: (...args: any[]) => void): ClientRequest

- Overrides OutgoingMessage.prependListener

  Adds the `listener` function to the beginning of the listeners array for the event named `eventName`. No checks are made to see if the `listener` has already been added. Multiple calls passing the same combination of `eventName`and `listener` will result in the `listener` being added, and called, multiple times.

      server.prependListener('connection', (stream) => {
        console.log('someone connected!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - ##### event: "abort"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "connect"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "continue"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "information"

  - ##### listener: (info: InformationEvent) => void

    - - (info: InformationEvent): void

      - #### Parameters

        - ##### info: InformationEvent

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "response"

  - ##### listener: (response: IncomingMessage) => void

    - - (response: IncomingMessage): void

      - #### Parameters

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "socket"

  - ##### listener: (socket: Socket) => void

    - - (socket: Socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "timeout"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "close"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "drain"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "finish"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "pipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: "unpipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependListener

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns ClientRequest

### prependOnceListener

- prependOnceListener(event: "abort", listener: () => void): ClientRequest
- prependOnceListener(event: "connect", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- prependOnceListener(event: "continue", listener: () => void): ClientRequest
- prependOnceListener(event: "information", listener: (info: InformationEvent) => void): ClientRequest
- prependOnceListener(event: "response", listener: (response: IncomingMessage) => void): ClientRequest
- prependOnceListener(event: "socket", listener: (socket: Socket) => void): ClientRequest
- prependOnceListener(event: "timeout", listener: () => void): ClientRequest
- prependOnceListener(event: "upgrade", listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void): ClientRequest
- prependOnceListener(event: "close", listener: () => void): ClientRequest
- prependOnceListener(event: "drain", listener: () => void): ClientRequest
- prependOnceListener(event: "error", listener: (err: <internal>.Error) => void): ClientRequest
- prependOnceListener(event: "finish", listener: () => void): ClientRequest
- prependOnceListener(event: "pipe", listener: (src: <internal>.Readable) => void): ClientRequest
- prependOnceListener(event: "unpipe", listener: (src: <internal>.Readable) => void): ClientRequest
- prependOnceListener(event: string | symbol, listener: (...args: any[]) => void): ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  Adds a one-time `listener` function for the event named `eventName` to the_beginning_ of the listeners array. The next time `eventName` is triggered, this listener is removed, and then invoked.

      server.prependOnceListener('connection', (stream) => {
        console.log('Ah, we have our first user!');
      });

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - ##### event: "abort"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "connect"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "continue"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "information"

  - ##### listener: (info: InformationEvent) => void

    - - (info: InformationEvent): void

      - #### Parameters

        - ##### info: InformationEvent

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "response"

  - ##### listener: (response: IncomingMessage) => void

    - - (response: IncomingMessage): void

      - #### Parameters

        - ##### response: IncomingMessage

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "socket"

  - ##### listener: (socket: Socket) => void

    - - (socket: Socket): void

      - #### Parameters

        - ##### socket: Socket

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "timeout"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "upgrade"

  - ##### listener: (response: IncomingMessage, socket: Socket, head: <internal>.Buffer) => void

    - - (response: IncomingMessage, socket: Socket, head: <internal>.Buffer): void

      - #### Parameters

        - ##### response: IncomingMessage

        - ##### socket: Socket

        - ##### head: <internal>.Buffer

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "close"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "drain"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "finish"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "pipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: "unpipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Overrides OutgoingMessage.prependOnceListener

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns ClientRequest

### rawListeners

- rawListeners(eventName: string | symbol): Function[]

- Inherited from OutgoingMessage.rawListeners

  Returns a copy of the array of listeners for the event named `eventName`, including any wrappers (such as those created by `.once()`).

      const emitter = new EventEmitter();
      emitter.once('log', () => console.log('log once'));

      // Returns a new Array with a function `onceWrapper` which has a property
      // `listener` which contains the original listener bound above
      const listeners = emitter.rawListeners('log');
      const logFnWrapper = listeners[0];

      // Logs "log once" to the console and does not unbind the `once` event
      logFnWrapper.listener();

      // Logs "log once" to the console and removes the listener
      logFnWrapper();

      emitter.on('log', () => console.log('log persistently'));
      // Will return a new Array with a single function bound by `.on()` above
      const newListeners = emitter.rawListeners('log');

      // Logs "log persistently" twice
      newListeners[0]();
      emitter.emit('log');

  since

    v9.4.0

  #### Parameters

  - ##### eventName: string | symbol

  #### Returns Function[]

### removeAllListeners

- removeAllListeners(event?: string | symbol): ClientRequest

- Inherited from OutgoingMessage.removeAllListeners

  Removes all listeners, or those of the specified `eventName`.

  It is bad practice to remove listeners added elsewhere in the code, particularly when the `EventEmitter` instance was created by some other component or module (e.g. sockets or file streams).

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v0.1.26

  #### Parameters

  - ##### Optional event: string | symbol

  #### Returns ClientRequest

### removeHeader

- removeHeader(name: string): void

- Inherited from OutgoingMessage.removeHeader

  Removes a header that is queued for implicit sending.

      outgoingMessage.removeHeader('Content-Encoding');

  since

    v0.4.0

  #### Parameters

  - ##### name: string

  #### Returns void

### removeListener

- removeListener(event: "close", listener: () => void): ClientRequest
- removeListener(event: "drain", listener: () => void): ClientRequest
- removeListener(event: "error", listener: (err: <internal>.Error) => void): ClientRequest
- removeListener(event: "finish", listener: () => void): ClientRequest
- removeListener(event: "pipe", listener: (src: <internal>.Readable) => void): ClientRequest
- removeListener(event: "unpipe", listener: (src: <internal>.Readable) => void): ClientRequest
- removeListener(event: string | symbol, listener: (...args: any[]) => void): ClientRequest

- Inherited from OutgoingMessage.removeListener

  Removes the specified `listener` from the listener array for the event named`eventName`.

      const callback = (stream) => {
        console.log('someone connected!');
      };
      server.on('connection', callback);
      // ...
      server.removeListener('connection', callback);

  `removeListener()` will remove, at most, one instance of a listener from the listener array. If any single listener has been added multiple times to the listener array for the specified `eventName`, then `removeListener()` must be called multiple times to remove each instance.

  Once an event is emitted, all listeners attached to it at the time of emitting are called in order. This implies that any`removeListener()` or `removeAllListeners()` calls after emitting and_before_ the last listener finishes execution will not remove them from`emit()` in progress. Subsequent events behave as expected.

      const myEmitter = new MyEmitter();

      const callbackA = () => {
        console.log('A');
        myEmitter.removeListener('event', callbackB);
      };

      const callbackB = () => {
        console.log('B');
      };

      myEmitter.on('event', callbackA);

      myEmitter.on('event', callbackB);

      // callbackA removes listener callbackB but it will still be called.
      // Internal listener array at time of emit [callbackA, callbackB]
      myEmitter.emit('event');
      // Prints:
      //   A
      //   B

      // callbackB is now removed.
      // Internal listener array [callbackA]
      myEmitter.emit('event');
      // Prints:
      //   A

  Because listeners are managed using an internal array, calling this will change the position indices of any listener registered after the listener being removed. This will not impact the order in which listeners are called, but it means that any copies of the listener array as returned by the `emitter.listeners()` method will need to be recreated.

  When a single function has been added as a handler multiple times for a single event (as in the example below), `removeListener()` will remove the most recently added instance. In the example the `once('ping')`listener is removed:

      const ee = new EventEmitter();

      function pong() {
        console.log('pong');
      }

      ee.on('ping', pong);
      ee.once('ping', pong);
      ee.removeListener('ping', pong);

      ee.emit('ping');
      ee.emit('ping');

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  #### Parameters

  - ##### event: "close"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Inherited from OutgoingMessage.removeListener

  #### Parameters

  - ##### event: "drain"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Inherited from OutgoingMessage.removeListener

  #### Parameters

  - ##### event: "error"

  - ##### listener: (err: <internal>.Error) => void

    - - (err: <internal>.Error): void

      - #### Parameters

        - ##### err: <internal>.Error

        #### Returns void

  #### Returns ClientRequest

- Inherited from OutgoingMessage.removeListener

  #### Parameters

  - ##### event: "finish"

  - ##### listener: () => void

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

- Inherited from OutgoingMessage.removeListener

  #### Parameters

  - ##### event: "pipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Inherited from OutgoingMessage.removeListener

  #### Parameters

  - ##### event: "unpipe"

  - ##### listener: (src: <internal>.Readable) => void

    - - (src: <internal>.Readable): void

      - #### Parameters

        - ##### src: <internal>.Readable

        #### Returns void

  #### Returns ClientRequest

- Inherited from OutgoingMessage.removeListener

  #### Parameters

  - ##### event: string | symbol

  - ##### listener: (...args: any[]) => void

    - - (...args: any[]): void

      - #### Parameters

        - ##### Rest ...args: any[]

        #### Returns void

  #### Returns ClientRequest

### setDefaultEncoding

- setDefaultEncoding(encoding: BufferEncoding): ClientRequest

- Inherited from OutgoingMessage.setDefaultEncoding

  The `writable.setDefaultEncoding()` method sets the default `encoding` for a `Writable` stream.

  since

    v0.11.15

  #### Parameters

  - ##### encoding: BufferEncoding

    The new default encoding

  #### Returns ClientRequest

### setHeader

- setHeader(name: string, value: string | number | readonly string[]): ClientRequest

- Inherited from OutgoingMessage.setHeader

  Sets a single header value for the header object.

  since

    v0.4.0

  #### Parameters

  - ##### name: string

    Header name

  - ##### value: string | number | readonly string[]

    Header value

  #### Returns ClientRequest

### setMaxListeners

- setMaxListeners(n: number): ClientRequest

- Inherited from OutgoingMessage.setMaxListeners

  By default `EventEmitter`s will print a warning if more than `10` listeners are added for a particular event. This is a useful default that helps finding memory leaks. The `emitter.setMaxListeners()` method allows the limit to be modified for this specific `EventEmitter` instance. The value can be set to`Infinity` (or `0`) to indicate an unlimited number of listeners.

  Returns a reference to the `EventEmitter`, so that calls can be chained.

  since

    v0.3.5

  #### Parameters

  - ##### n: number

  #### Returns ClientRequest

### setNoDelay

- setNoDelay(noDelay?: boolean): void

- Once a socket is assigned to this request and is connected `socket.setNoDelay()` will be called.

  since

    v0.5.9

  #### Parameters

  - ##### Optional noDelay: boolean

  #### Returns void

### setSocketKeepAlive

- setSocketKeepAlive(enable?: boolean, initialDelay?: number): void

- Once a socket is assigned to this request and is connected `socket.setKeepAlive()` will be called.

  since

    v0.5.9

  #### Parameters

  - ##### Optional enable: boolean

  - ##### Optional initialDelay: number

  #### Returns void

### setTimeout

- setTimeout(timeout: number, callback?: () => void): ClientRequest

- Overrides OutgoingMessage.setTimeout

  Once a socket is assigned to this request and is connected `socket.setTimeout()` will be called.

  since

    v0.5.9

  #### Parameters

  - ##### timeout: number

    Milliseconds before a request times out.

  - ##### Optional callback: () => void

    Optional function to be called when a timeout occurs. Same as binding to the `'timeout'` event.

    - - (): void

      - #### Returns void

  #### Returns ClientRequest

### uncork

- uncork(): void

- Inherited from OutgoingMessage.uncork

  The `writable.uncork()` method flushes all data buffered since cork was called.

  When using `writable.cork()` and `writable.uncork()` to manage the buffering of writes to a stream, it is recommended that calls to `writable.uncork()` be deferred using `process.nextTick()`. Doing so allows batching of all`writable.write()` calls that occur within a given Node.js event loop phase.

      stream.cork();
      stream.write('some ');
      stream.write('data ');
      process.nextTick(() => stream.uncork());

  If the `writable.cork()` method is called multiple times on a stream, the same number of calls to `writable.uncork()` must be called to flush the buffered data.

      stream.cork();
      stream.write('some ');
      stream.cork();
      stream.write('data ');
      process.nextTick(() => {
        stream.uncork();
        // The data will not be flushed until uncork() is called a second time.
        stream.uncork();
      });

  See also: `writable.cork()`.

  since

    v0.11.2

  #### Returns void

### write

- write(chunk: any, callback?: (error: <internal>.Error) => void): boolean
- write(chunk: any, encoding: BufferEncoding, callback?: (error: <internal>.Error) => void): boolean

- Inherited from OutgoingMessage.write

  The `writable.write()` method writes some data to the stream, and calls the supplied `callback` once the data has been fully handled. If an error occurs, the `callback` will be called with the error as its first argument. The `callback` is called asynchronously and before `'error'` is emitted.

  The return value is `true` if the internal buffer is less than the`highWaterMark` configured when the stream was created after admitting `chunk`. If `false` is returned, further attempts to write data to the stream should stop until the `'drain'` event is emitted.

  While a stream is not draining, calls to `write()` will buffer `chunk`, and return false. Once all currently buffered chunks are drained (accepted for delivery by the operating system), the `'drain'` event will be emitted. It is recommended that once `write()` returns false, no more chunks be written until the `'drain'` event is emitted. While calling `write()` on a stream that is not draining is allowed, Node.js will buffer all written chunks until maximum memory usage occurs, at which point it will abort unconditionally. Even before it aborts, high memory usage will cause poor garbage collector performance and high RSS (which is not typically released back to the system, even after the memory is no longer required). Since TCP sockets may never drain if the remote peer does not read the data, writing a socket that is not draining may lead to a remotely exploitable vulnerability.

  Writing data while the stream is not draining is particularly problematic for a `Transform`, because the `Transform` streams are paused by default until they are piped or a `'data'` or `'readable'` event handler is added.

  If the data to be written can be generated or fetched on demand, it is recommended to encapsulate the logic into a `Readable` and use pipe. However, if calling `write()` is preferred, it is possible to respect backpressure and avoid memory issues using the `'drain'` event:

      function write(data, cb) {
        if (!stream.write(data)) {
          stream.once('drain', cb);
        } else {
          process.nextTick(cb);
        }
      }

      // Wait for cb to be called before doing any other write.
      write('hello', () => {
        console.log('Write completed, do more writes now.');
      });

  A `Writable` stream in object mode will always ignore the `encoding` argument.

  since

    v0.9.4

  #### Parameters

  - ##### chunk: any

    Optional data to write. For streams not operating in object mode, `chunk` must be a string, `Buffer` or `Uint8Array`. For object mode streams, `chunk` may be any JavaScript value other than `null`.

  - ##### Optional callback: (error: <internal>.Error) => void

    Callback for when this chunk of data is flushed.

    - - (error: <internal>.Error): void

      - #### Parameters

        - ##### error: <internal>.Error

        #### Returns void

  #### Returns boolean

  `false` if the stream wishes for the calling code to wait for the `'drain'` event to be emitted before continuing to write additional data; otherwise `true`.

- Inherited from OutgoingMessage.write

  #### Parameters

  - ##### chunk: any

  - ##### encoding: BufferEncoding

  - ##### Optional callback: (error: <internal>.Error) => void

    - - (error: <internal>.Error): void

      - #### Parameters

        - ##### error: <internal>.Error

        #### Returns void

  #### Returns boolean

### Static getEventListeners

- getEventListeners(emitter: <internal>.EventEmitter | DOMEventTarget, name: string | symbol): Function[]

- Inherited from OutgoingMessage.getEventListeners

  Returns a copy of the array of listeners for the event named `eventName`.

  For `EventEmitter`s this behaves exactly the same as calling `.listeners` on the emitter.

  For `EventTarget`s this is the only way to get the event listeners for the event target. This is useful for debugging and diagnostic purposes.

      const { getEventListeners, EventEmitter } = require('events');

      {
        const ee = new EventEmitter();
        const listener = () => console.log('Events are fun');
        ee.on('foo', listener);
        getEventListeners(ee, 'foo'); // [listener]
      }
      {
        const et = new EventTarget();
        const listener = () => console.log('Events are fun');
        et.addEventListener('foo', listener);
        getEventListeners(et, 'foo'); // [listener]
      }

  since

    v15.2.0

  #### Parameters

  - ##### emitter: <internal>.EventEmitter | DOMEventTarget

  - ##### name: string | symbol

  #### Returns Function[]

### Static listenerCount

- listenerCount(emitter: <internal>.EventEmitter, eventName: string | symbol): number

- Inherited from OutgoingMessage.listenerCount

  A class method that returns the number of listeners for the given `eventName`registered on the given `emitter`.

      const { EventEmitter, listenerCount } = require('events');
      const myEmitter = new EventEmitter();
      myEmitter.on('event', () => {});
      myEmitter.on('event', () => {});
      console.log(listenerCount(myEmitter, 'event'));
      // Prints: 2

  since

    v0.9.12

  deprecated

    Since v3.2.0 - Use `listenerCount` instead.

  #### Parameters

  - ##### emitter: <internal>.EventEmitter

    The emitter to query

  - ##### eventName: string | symbol

    The event name

  #### Returns number

### Static on

- on(emitter: <internal>.EventEmitter, eventName: string, options?: StaticEventEmitterOptions): AsyncIterableIterator<any>

- Inherited from OutgoingMessage.on

  ```js const { on, EventEmitter } = require('events');

  (async () => { const ee = new EventEmitter();

  // Emit later on process.nextTick(() => { ee.emit('foo', 'bar'); ee.emit('foo', 42); });

  for await (const event of on(ee, 'foo')) { // The execution of this inner block is synchronous and it // processes one event at a time (even with await). Do not use // if concurrent execution is required. console.log(event); // prints ['bar'] [42] } // Unreachable here })();

      Returns an `AsyncIterator` that iterates `eventName` events. It will throw
      if the `EventEmitter` emits `'error'`. It removes all listeners when
      exiting the loop. The `value` returned by each iteration is an array
      composed of the emitted event arguments.

      An `AbortSignal` can be used to cancel waiting on events:

      ```js
      const { on, EventEmitter } = require('events');
      const ac = new AbortController();

      (async () => {
        const ee = new EventEmitter();

        // Emit later on
        process.nextTick(() => {
          ee.emit('foo', 'bar');
          ee.emit('foo', 42);
        });

        for await (const event of on(ee, 'foo', { signal: ac.signal })) {
          // The execution of this inner block is synchronous and it
          // processes one event at a time (even with await). Do not use
          // if concurrent execution is required.
          console.log(event); // prints ['bar'] [42]
        }
        // Unreachable here
      })();

      process.nextTick(() => ac.abort());

  since

    v13.6.0, v12.16.0

  #### Parameters

  - ##### emitter: <internal>.EventEmitter

  - ##### eventName: string

    The name of the event being listened for

  - ##### Optional options: StaticEventEmitterOptions

  #### Returns AsyncIterableIterator<any>

  that iterates `eventName` events emitted by the `emitter`

### Static once

- once(emitter: NodeEventTarget, eventName: string | symbol, options?: StaticEventEmitterOptions): Promise<any[]>
- once(emitter: DOMEventTarget, eventName: string, options?: StaticEventEmitterOptions): Promise<any[]>

- Inherited from OutgoingMessage.once

  Creates a `Promise` that is fulfilled when the `EventEmitter` emits the given event or that is rejected if the `EventEmitter` emits `'error'` while waiting. The `Promise` will resolve with an array of all the arguments emitted to the given event.

  This method is intentionally generic and works with the web platform EventTarget interface, which has no special`'error'` event semantics and does not listen to the `'error'` event.

      const { once, EventEmitter } = require('events');

      async function run() {
        const ee = new EventEmitter();

        process.nextTick(() => {
          ee.emit('myevent', 42);
        });

        const [value] = await once(ee, 'myevent');
        console.log(value);

        const err = new Error('kaboom');
        process.nextTick(() => {
          ee.emit('error', err);
        });

        try {
          await once(ee, 'myevent');
        } catch (err) {
          console.log('error happened', err);
        }
      }

      run();

  The special handling of the `'error'` event is only used when `events.once()`is used to wait for another event. If `events.once()` is used to wait for the '`error'` event itself, then it is treated as any other kind of event without special handling:

      const { EventEmitter, once } = require('events');

      const ee = new EventEmitter();

      once(ee, 'error')
        .then(([err]) => console.log('ok', err.message))
        .catch((err) => console.log('error', err.message));

      ee.emit('error', new Error('boom'));

      // Prints: ok boom

  An `AbortSignal` can be used to cancel waiting for the event:

      const { EventEmitter, once } = require('events');

      const ee = new EventEmitter();
      const ac = new AbortController();

      async function foo(emitter, event, signal) {
        try {
          await once(emitter, event, { signal });
          console.log('event emitted!');
        } catch (error) {
          if (error.name === 'AbortError') {
            console.error('Waiting for the event was canceled!');
          } else {
            console.error('There was an error', error.message);
          }
        }
      }

      foo(ee, 'foo', ac.signal);
      ac.abort(); // Abort waiting for the event
      ee.emit('foo'); // Prints: Waiting for the event was canceled!

  since

    v11.13.0, v10.16.0

  #### Parameters

  - ##### emitter: NodeEventTarget

  - ##### eventName: string | symbol

  - ##### Optional options: StaticEventEmitterOptions

  #### Returns Promise<any[]>

- Inherited from OutgoingMessage.once

  #### Parameters

  - ##### emitter: DOMEventTarget

  - ##### eventName: string

  - ##### Optional options: StaticEventEmitterOptions

  #### Returns Promise<any[]>

Generated using TypeDoc